% --------------------------------------------------------------
\subsection{The Helmholtz problem with Neumann boundary conditions}
% --------------------------------------------------------------
\label{neumann-dg}%
\pbindex{Poisson}%
\cindex{boundary condition!Dirichlet}%

The Poisson problem with
non-homogeneous Neumann boundary conditions has been already
introduced in volume~1, section~\ref{sec-neumann-nh}, page~\pageref{sec-neumann-nh}:

\ \ $(P)$: \emph{find $u$, defined in $\Omega$, such that}
\begin{eqnarray*}
      u-\Delta u &=& f \ {\rm in}\ \Omega        
        \\
      \Frac{\partial u}{\partial n} &=& g \ {\rm on}\ \partial \Omega
\end{eqnarray*}
where $f$ and $g$ are given.
%
We introduce the folowing bilinear form $a_h(.,.)$ and linear for $l_h(.)$,
defined for all $u,v\in H^1(\mathcal{T}_h)$ by
(see e.g.~\citealp[p.~127]{PieErn-2012}, eqn. (4.16)):
\cindex{form!{$\jump{u}\jump{v}$}}%
\cindex{form!{$\jump{u}\average{\nabla_h v.{\bf n}}$}}%
\begin{eqnarray}
  a_h(u,v)
    &=&
    \int_\Omega
	\left(
          u \, v
          +
          \nabla_h u .\nabla_h v
        \right)
	\,{\rm d}x
    \\
    && + \  
    \sum_{S \in \mathscr{S}_h^{(i)}}
    \int_S
        \left(
	      \beta\varpi_s
              \, \jump{u} \, \jump{v}
              - 
              \average{\nabla_h u.{\bf n}}
              \, \jump{v}
              -
              \jump{u}
              \, \average{\nabla_h v.{\bf n}}
        \right)
        \, {\rm d}s
	\label{eq-numann-dg-ah}
    \\
  l_h(v)
    &=&
    \int_\Omega
	f\,u 
	\,{\rm d}x
    +
    \int_{\partial\Omega}
	g \, v 
	\,{\rm d}s
	\label{eq-numann-dg-lh}
\end{eqnarray}
Let us comment the changes between these forms and 
those used for the Poisson problem with Dirichlet boundary conditions.
The Poisson operator $-\Delta$ has been replaced by the Helmholtz one $I-\Delta$
in order to have an unique solution.
Remark also that the sum is performed in~\eqref{eq-dirichlet-dg-ah}
for all internal sides in $\mathscr{S}_h^{(i)}$,
while, in~\eqref{eq-dirichlet-dg-ah}, for Dirichlet boundary conditions,
it was for all sides in $\mathscr{S}_h$,
i.e. for both boundary and internal sides.
Also, the right-hand-side linear form $l_h(.)$.
do no more involves any sum over sides.

Finally, the discrete variational formulation writes:

\ \ $(FV)_h$: \emph{find $u_h\in X_h$ such that}
\begin{eqnarray*}
  a_h(u_h,v_h) &=& l_h(v_h), \ \forall v_h\in X_h
\end{eqnarray*}

The following code implement this problem in the \Rheolef\  environment.

% ---------------------------------------
\myexamplelicense{neumann_dg.cc}
% ---------------------------------------

% ------------------------------
\subsubsection*{Comments}
% ------------------------------
The right-hand side $f$ and $g$ are given by \eqref{eq-sinusprod},
volume~1, page~\pageref{eq-cosinusprod}.
In that case, the exact solution is known.
Running the program is obtained from the non-homogeneous Dirichlet case,
by replacing \code{dirichlet_dg} by \code{neumann_dg}.

